Merge commit 'dkg/master'
[monkeysphere.git] / src / monkeysphere-server
index 9205b1d315bce9b59cdfecb85df952012425d38a..4d7acc6cb50276bb7a46ae589d3c6995ed540252 100755 (executable)
@@ -37,7 +37,7 @@ usage: $PGRM <subcommand> [options] [args]
 MonkeySphere server admin tool.
 
 subcommands:
-  update-users (u) [USER]...            update users authorized_keys files
+  update-users (u) [USER]...            update user authorized_keys files
 
   gen-key (g) [HOSTNAME]                generate gpg key for the server
     -l|--length BITS                      key length in bits (2048)
@@ -47,12 +47,14 @@ subcommands:
   publish-key (p)                       publish server's host key to keyserver
 
   add-identity-certifier (a) KEYID      import and tsign a certification key
-    -n|--domain DOMAIN                    domain of certifier ()
-    -t|--trust TRUST                      trust level of certifier ('full')
+    -n|--domain DOMAIN                    limit ID certifications to IDs in DOMAIN ()
+    -t|--trust TRUST                      trust level of certifier (full)
     -d|--depth DEPTH                      trust depth for certifier (1)
   remove-identity-certifier (r) KEYID   remove a certification key
   list-identity-certifiers (l)          list certification keys
 
+  gpg-authentication-cmd CMD            gnupg-authentication command
+
   help (h,?)                            this help
 
 EOF
@@ -141,6 +143,16 @@ update_users() {
 
        log "----- user: $uname -----"
 
+       if ! check_key_file_permissions "$uname" "$AUTHORIZED_USER_IDS" ; then
+           log "Improper permissions on authorized_user_ids file."
+           continue
+       fi
+
+       if ! check_key_file_permissions "$uname" "$RAW_AUTHORIZED_KEYS" ; then
+           log "Improper permissions on authorized_keys file."
+           continue
+       fi
+
         # make temporary directory
         TMPDIR=$(mktemp -d)
 
@@ -205,11 +217,56 @@ update_users() {
 
 # generate server gpg key
 gen_key() {
+    local keyType
+    local keyLength
+    local keyUsage
+    local keyExpire
+    local revoker
     local hostName
     local userID
     local keyParameters
     local fingerprint
 
+    # set default key parameter values
+    keyType="RSA"
+    keyLength="2048"
+    keyUsage="auth"
+    keyExpire=
+    revoker=
+
+    # get options
+    TEMP=$(getopt -o l:e:r: -l length:,expire:,revoker: -n "$PGRM" -- "$@")
+
+    if [ $? != 0 ] ; then
+       exit 1
+    fi
+
+    # Note the quotes around `$TEMP': they are essential!
+    eval set -- "$TEMP"
+
+    while true ; do
+       case "$1" in
+           -l|--length)
+               keyLength="$2"
+               shift 2
+               ;;
+           -e|--expire)
+               keyExpire="$2"
+               shift 2
+               ;;
+           -r|--revoker)
+               revoker="$2"
+               shift 2
+               ;;
+           --)
+               shift
+               ;;
+            *)
+               break
+               ;;
+       esac
+    done
+
     hostName=${1:-$(hostname --fqdn)}
     userID="ssh://${hostName}"
 
@@ -218,12 +275,8 @@ gen_key() {
        failure "Key for '$userID' already exists"
     fi
 
-    # set key variables
-    KEY_TYPE="RSA"
-    KEY_LENGTH=${KEY_LENGTH:="2048"}
-    KEY_USAGE="auth"
     # prompt about key expiration if not specified
-    if [ -z "$KEY_EXPIRE" ] ; then
+    if [ -z "$keyExpire" ] ; then
        cat <<EOF
 Please specify how long the key should be valid.
          0 = key does not expire
@@ -232,33 +285,33 @@ Please specify how long the key should be valid.
       <n>m = key expires in n months
       <n>y = key expires in n years
 EOF
-       while [ -z "$KEY_EXPIRE" ] ; do
-           read -p "Key is valid for? (0) " KEY_EXPIRE
-           if ! test_gpg_expire ${KEY_EXPIRE:=0} ; then
+       while [ -z "$keyExpire" ] ; do
+           read -p "Key is valid for? (0) " keyExpire
+           if ! test_gpg_expire ${keyExpire:=0} ; then
                echo "invalid value"
-               unset KEY_EXPIRE
+               unset keyExpire
            fi
        done
-    elif ! test_gpg_expire "$KEY_EXPIRE" ; then
-       failure "invalid key expiration value '$KEY_EXPIRE'."
+    elif ! test_gpg_expire "$keyExpire" ; then
+       failure "invalid key expiration value '$keyExpire'."
     fi
 
     # set key parameters
     keyParameters=$(cat <<EOF
-Key-Type: $KEY_TYPE
-Key-Length: $KEY_LENGTH
-Key-Usage: $KEY_USAGE
+Key-Type: $keyType
+Key-Length: $keyLength
+Key-Usage: $keyUsage
 Name-Real: $userID
-Expire-Date: $KEY_EXPIRE
+Expire-Date: $keyExpire
 EOF
 )
 
     # add the revoker field if specified
     # FIXME: the "1:" below assumes that $REVOKER's key is an RSA key.
     # FIXME: key is marked "sensitive"?  is this appropriate?
-    if [ "$REVOKER" ] ; then
+    if [ "$revoker" ] ; then
        keyParameters="${keyParameters}"$(cat <<EOF
-Revoker: 1:$REVOKER sensitive
+Revoker: 1:$revoker sensitive
 EOF
 )
     fi
@@ -305,7 +358,7 @@ fingerprint_server_key() {
 
 # publish server key to keyserver
 publish_server_key() {
-    read -p "really publish key to $KEYSERVER? (y/N) " OK; OK=${OK:=N}
+    read -p "Really publish key to $KEYSERVER? (y/N) " OK; OK=${OK:=N}
     if [ ${OK/y/Y} != 'Y' ] ; then
        failure "aborting."
     fi
@@ -314,25 +367,73 @@ publish_server_key() {
     # FIXME: need to figure out better way to identify host key
     # dummy command so as not to publish fakes keys during testing
     # eventually:
-    #gpg_authentication "--keyring $GNUPGHOME_HOST/pubring.gpg --keyserver $KEYSERVER --send-keys $(hostname -f)"
-    failure "NOT PUBLISHED (to avoid permanent publication errors during monkeysphere development)."
+    #gpg_authentication "--keyserver $KEYSERVER --send-keys $(hostname -f)"
+    echo "NOT PUBLISHED (to avoid permanent publication errors during monkeysphere development)."
+    echo "The following command should publish the key:"
+    echo "monkeysphere-server gpg-authentication-cmd '--keyserver $KEYSERVER --send-keys $(hostname -f)'"
+    exit 255
 }
 
 # retrieve key from web of trust, import it into the host keyring, and
 # ltsign the key in the host keyring so that it may certify other keys
 add_certifier() {
+    local domain
+    local trust
+    local depth
     local keyID
     local fingerprint
     local ltsignCommand
+    local trustval
+
+    # set default values for trust depth and domain
+    domain=
+    trust=full
+    depth=1
+
+    # get options
+    TEMP=$(getopt -o n:t:d: -l domain:,trust:,depth: -n "$PGRM" -- "$@")
+
+    if [ $? != 0 ] ; then
+       exit 1
+    fi
+
+    # Note the quotes around `$TEMP': they are essential!
+    eval set -- "$TEMP"
+
+    while true ; do
+       case "$1" in
+           -n|--domain)
+               domain="$2"
+               shift 2
+               ;;
+           -t|--trust)
+               trust="$2"
+               shift 2
+               ;;
+           -d|--depth)
+               depth="$2"
+               shift 2
+               ;;
+           --)
+               shift
+               ;;
+            *)
+               break
+               ;;
+       esac
+    done
 
     keyID="$1"
+    if [ -z "$keyID" ] ; then
+       failure "You must specify the key ID of a key to add."
+    fi
     export keyID
 
     # export host ownertrust to authentication keyring
     gpg_host --export-ownertrust | gpg_authentication "--import-ownertrust"
 
     # get the key from the key server
-    gpg_authentication "--keyserver $KEYSERVER --recv-key '$keyID'" || failure
+    gpg_authentication "--keyserver $KEYSERVER --recv-key '$keyID'"
 
     # get the full fingerprint of a key ID
     fingerprint=$(gpg_authentication "--list-key --with-colons --with-fingerprint $keyID" | \
@@ -341,7 +442,8 @@ add_certifier() {
     echo "key found:"
     gpg_authentication "--fingerprint $fingerprint"
 
-    read -p "Are you sure you want to add this key as a certifier of users on this system? (y/N) " OK; OK=${OK:-N}
+    echo "Are you sure you want to add this key as a certifier of"
+    read -p "users on this system? (y/N) " OK; OK=${OK:-N}
     if [ "${OK/y/Y}" != 'Y' ] ; then
        failure "aborting."
     fi
@@ -349,19 +451,22 @@ add_certifier() {
     # export the key to the host keyring
     gpg_authentication "--export $keyID" | gpg_host --import
 
-    # default values for trust depth and domain
-    DOMAIN=${DOMAIN:-}
-    TRUST=${TRUST:-2}
-    DEPTH=${DEPTH:-1}
+    if [ "$trust" == marginal ]; then
+       trustval=1
+    elif [ "$trust" == full ]; then
+       trustval=2
+    else
+       failure "trust value requested ('$trust') was unclear (only 'marginal' or 'full' are supported)"
+    fi
 
     # ltsign command
     # NOTE: *all* user IDs will be ltsigned
     ltsignCommand=$(cat <<EOF
 ltsign
 y
-$TRUST
-$DEPTH
-$DOMAIN
+$trustval
+$depth
+$domain
 y
 save
 EOF
@@ -380,6 +485,9 @@ remove_certifier() {
     local fingerprint
 
     keyID="$1"
+    if [ -z "$keyID" ] ; then
+       failure "You must specify the key ID of a key to remove."
+    fi
 
     # delete the requested key (with prompting)
     gpg_host --delete-key "$keyID"
@@ -393,6 +501,11 @@ list_certifiers() {
     gpg_host --list-keys
 }
 
+# issue command to gpg-authentication keyring
+gpg_authentication_cmd() {
+    gpg_authentication "$@"
+}
+
 ########################################################################
 # MAIN
 ########################################################################
@@ -435,60 +548,6 @@ COMMAND="$1"
 [ "$COMMAND" ] || failure "Type '$PGRM help' for usage."
 shift
 
-# unset option variables
-unset KEY_LENGTH
-unset KEY_EXPIRE
-unset REVOKER
-unset DOMAIN
-unset TRUST
-unset DEPTH
-
-# get options for key generation and add-certifier functions
-TEMP=$(getopt -o l:e:r:n:t:d: -l length:,expire:,revoker:,domain:,trust:,depth: -n "$PGRM" -- "$@")
-
-if [ $? != 0 ] ; then
-    usage
-    exit 1
-fi
-
-# Note the quotes around `$TEMP': they are essential!
-eval set -- "$TEMP"
-
-while true ; do
-    case "$1" in
-       -l|--length)
-           KEY_LENGTH="$2"
-           shift 2
-           ;;
-       -e|--expire)
-           KEY_EXPIRE="$2"
-           shift 2
-           ;;
-       -r|--revoker)
-           REVOKER="$2"
-           shift 2
-           ;;
-       -n|--domain)
-           DOMAIN="$2"
-           shift 2
-           ;;
-       -t|--trust)
-           TRUST="$2"
-           shift 2
-           ;;
-       -d|--depth)
-           DEPTH="$2"
-           shift 2
-           ;;
-       --)
-           shift
-           ;;
-        *)
-            break
-            ;;
-    esac
-done
-
 case $COMMAND in
     'update-users'|'update-user'|'u')
        update_users "$@"
@@ -507,16 +566,10 @@ case $COMMAND in
        ;;
 
     'add-identity-certifier'|'add-certifier'|'a')
-       if [ -z "$1" ] ; then
-           failure "You must specify a key ID."
-       fi
        add_certifier "$1"
        ;;
 
     'remove-identity-certifier'|'remove-certifier'|'r')
-       if [ -z "$1" ] ; then
-           failure "You must specify a key ID."
-       fi
        remove_certifier "$1"
        ;;
 
@@ -524,6 +577,10 @@ case $COMMAND in
        list_certifiers "$@"
        ;;
 
+    'gpg-authentication-cmd')
+       gpg_authentication_cmd "$@"
+       ;;
+
     'help'|'h'|'?')
         usage
         ;;